10  REM          PROGRAM FOR CALCULATING S-PARAMATERS
20  REM                      FOR T NETWORKS
30  PRINT:PRINT, "k2uyh --- modified for ibm pc ---- wa2tif":PRINT
40  REM ******************* SIGN ON *************************************
50  REM
60  PRINT "PROGRAM FOR COMPUTING S-PARAMETERS OF TWO PORT T NETWORKS"
70  PRINT
80  REM
90  REM ************ INPUT OF COMPONENT VALUES **************************
100  REM
105  PI=3.1416
110  PRINT "CHARACTERISTIC IMPEDANCE =";
120  INPUT Z
130  PRINT
140  FOR I=1 TO 3 STEP 1
150  PRINT "REAL PART OF Z";I;"=";
160  INPUT R(I)
170  PRINT "IMAGINERY PART OF Z";I;"=";
180  INPUT X(I)
190  R(I)= R(I)/Z
200  X(I)= X(I)/Z
210  PRINT
220  NEXT I
230  REM **************  CALCULATION OF S11 *****************************
240  REM
250  REM PRECISION (5)
260  DIM I(10)
270  DIM D(5)
280  DIM S(5)
290  T1= SQR((1+R(3))^2 + X(3)^2)
300  A1= ATN(X(3)/(1+R(3)))
310  T2= SQR(R(2)^2 + X(2)^2)
320  A2= ATN(X(2)/R(2))
330  T3= SQR((1+R(3)+R(2))^2 + (X(3)+X(2))^2)
340  A3= ATN((X(3)+X(2))/(1+R(2)+R(3)))
350  T4= (T1*T2)/T3
360  A4= A1+A2-A3
370  T5= R(1) + COS(A4)*T4
380  T6= X(1) + SIN(A4)*T4
390  S(1)= SQR((T5-1)^2 + T6^2)/SQR((T5+1)^2 + T6^2)
400  D(1)= ATN(T6/(T5-1)) - ATN(T6/(T5+1))
410  REM
420  REM ************** CALCULATION OF S22 ******************************
430  REM
440  T1= SQR((1+R(1))^2 + X(1)^2)
450  A1= ATN(X(1)/(1+R(1)))
460  T2= SQR(R(2)^2 + X(2)^2)
470  A2= ATN(X(2)/R(2))
480  T3= SQR((1+R(1)+R(2))^2 + (X(1)+X(2))^2)
490  A3= ATN((X(1)+X(2))/(1+R(1)+R(2)))
500  T4= (T1*T2)/T3
510  A4= A1+A2-A3
520  T5= R(3) + COS(A4)*T4
530  T6= X(3) + SIN(A4)*T4
540  S(2)= SQR((T5-1)^2 + T6^2)/SQR((T5+1)^2 + T6^2)
550  D(2)= ATN(T6/(T5-1)) - ATN(T6/(T5+1))
560  REM
570  REM ***************** CALCULATION OF S21 AND S12 *******************
580  REM
590  T1= SQR(R(2)^2 + X(2)^2)
600  A1= ATN(X(2)/R(2))
610  T2= SQR((1+R(1)+R(2))^2 + (X(1)+X(2))^2)
620  A2= ATN((X(1)+X(2))/(1+R(1)+R(2)))
630  T3= T1/T2
640  A3= A1-A2
650  T4= SQR((1+R(1))^2 + X(1)^2)
660  A4= ATN(X(1)/(1+R(1)))
670  T5= SQR(R(2)^2 + X(2)^2)
680  A5= ATN(X(2)/R(2))
690  T6= SQR((1+R(1)+R(2))^2 + (X(1)+X(2))^2)
700  A6= ATN((X(1)+X(2))/(1+R(1)+R(2)))
710  T7= (T4*T5)/T6
720  A7= T4+T5-T6
730  A7=A7*(180/PI)
740  T8= SQR((1+R(3)+COS(A7)*T7)^2 + (X(3)+SIN(A7)*T7)^2)
750  A8= ATN((X(3)+SIN(A7)*T7)/(1+R(3)+C0S(A7)*T7))
760  T9= T3/T8
770  A9= A3-A8
780  T1= SQR((1+COS(D(1))*S(1))^2 + (SIN(D(1))*S(1))^2)
790  A1=ATN((SIN(D(1))*S(1))/(1+COS(D(1))*S(1)))
800  S(3)= T9*T1
810  D(3)= A9+A1
820  S(4)= S(3)
830  D(4)= D(3)
840  REM
850  REM ************** CONVERT FROM RADIANS TO DEGREES *****************
860  REM
870  FOR C=1 TO 4 STEP 1
880  D(C)=D(C)*(180/PI)
890  NEXT C
900  REM
910  REM ***************** OUTPUT RESULTS *******************************
920  REM
930  PRINT
940  PRINT "PARAMETER","  S11","  S22","  S21","  S12"
950  PRINT
960  PRINT "MAGNITUDE",S(1),S(2),S(3),S(4)
970  PRINT
980  PRINT "ANGLE",D(1),D(2),D(3),D(4)
990  END
